"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodejsFunction = void 0;
const lambda = __importStar(require("@aws-cdk/aws-lambda"));
const es = __importStar(require("esbuild"));
const path = __importStar(require("path"));
const utils_1 = require("./utils");
const BUILD_FOLDER = '.build';
const DEFAULT_BUILD_OPTIONS = {
    bundle: true,
    target: 'es2017',
    external: ['aws-sdk'],
};
/**
 * A Node.js Lambda function bundled using `esbuild`
 */
class NodejsFunction extends lambda.Function {
    constructor(scope, id, props = {}) {
        var _a, _b;
        if (props.runtime && props.runtime.family !== lambda.RuntimeFamily.NODEJS) {
            throw new Error('Only `NODEJS` runtimes are supported.');
        }
        const projectRoot = utils_1.findProjectRoot(props.rootDir);
        if (!projectRoot) {
            throw new Error('Cannot find root directory. Please specify it with `rootDir` option.');
        }
        const handler = (_a = props.handler) !== null && _a !== void 0 ? _a : 'index.handler';
        const defaultRunTime = utils_1.nodeMajorVersion() >= 12
            ? lambda.Runtime.NODEJS_12_X
            : lambda.Runtime.NODEJS_10_X;
        const runtime = (_b = props.runtime) !== null && _b !== void 0 ? _b : defaultRunTime;
        const entry = utils_1.extractFileName(projectRoot, handler);
        es.buildSync(Object.assign(Object.assign(Object.assign({}, DEFAULT_BUILD_OPTIONS), props.esbuildOptions), { entryPoints: [entry], outdir: path.join(projectRoot, BUILD_FOLDER, path.dirname(entry)), platform: 'node' }));
        super(scope, id, Object.assign(Object.assign({}, props), { runtime, code: lambda.Code.fromAsset(path.join(projectRoot, BUILD_FOLDER)), handler }));
    }
}
exports.NodejsFunction = NodejsFunction;
