"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.nodeMajorVersion = exports.findProjectRoot = exports.findUp = exports.extractFileName = void 0;
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
function extractFileName(cwd, handler) {
    const fnName = path.extname(handler);
    const fnNameLastAppearanceIndex = handler.lastIndexOf(fnName);
    // replace only last instance to allow the same name for file and handler
    const fileName = handler.substring(0, fnNameLastAppearanceIndex);
    // Check if the .ts files exists. If so return that to watch
    if (fs.existsSync(path.join(cwd, fileName + '.ts'))) {
        return fileName + '.ts';
    }
    // Check if the .js files exists. If so return that to watch
    if (fs.existsSync(path.join(cwd, fileName + '.js'))) {
        return fileName + '.js';
    }
    // Can't find the files. Watch will have an exception anyway. So throw one with error.
    console.log(`Cannot locate handler - ${fileName} not found`);
    throw new Error('Compilation failed. Please ensure handler exists with ext .ts or .js');
}
exports.extractFileName = extractFileName;
/**
 * Find a file by walking up parent directories
 */
function findUp(name, directory = process.cwd()) {
    const absoluteDirectory = path.resolve(directory);
    if (fs.existsSync(path.join(directory, name))) {
        return directory;
    }
    const { root } = path.parse(absoluteDirectory);
    if (absoluteDirectory === root) {
        return undefined;
    }
    return findUp(name, path.dirname(absoluteDirectory));
}
exports.findUp = findUp;
function findProjectRoot(rootDir) {
    var _a, _b, _c;
    return (_c = (_b = (_a = rootDir !== null && rootDir !== void 0 ? rootDir : findUp(`.git${path.sep}`)) !== null && _a !== void 0 ? _a : findUp('yarn.lock')) !== null && _b !== void 0 ? _b : findUp('package-lock.json')) !== null && _c !== void 0 ? _c : findUp('package.json');
}
exports.findProjectRoot = findProjectRoot;
/**
 * Returns the major version of node installation
 */
function nodeMajorVersion() {
    return parseInt(process.versions.node.split('.')[0], 10);
}
exports.nodeMajorVersion = nodeMajorVersion;
